// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS16AO2/samples/sbtest/autocal.c $
// $Rev: 55949 $
// $Date: 2024-11-13 13:38:37 -0600 (Wed, 13 Nov 2024) $

// 16AISS16AO2: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AUTOCAL,
			/* arg		*/	0,
			/* reg		*/	AISS16AO2_GSC_BCR,
			/* mask		*/	0x30000000,
			/* value	*/	0x20000000
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= aiss16ao2_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);

	errs	+= service_ioctl_set_reg_list(fd, list);

	errs	+= aiss16ao2_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// This would require additional equipment.
	return(0);
}



/******************************************************************************
*
*	Function:	autocal_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AISS16AO2_IOCTL_AUTOCAL.
*		We can't verify that an autocalibration was performed, so we simply
*		check that the respective bits are correct afterwards.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int autocal_test(int fd)
{
	int	errs	= 0;

	gsc_label("AISS16AO2_IOCTL_AUTOCAL");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
	{
		printf("PASS\n");
	}
	else
	{
		printf("\n\n");
		printf("Autocalibration failures may arrise as the result of equipment being\n");
		printf("attached while Autocalibration is being performed. An Autocalibration\n");
		printf("failure is likely to cause a cascade of numerous additional feature test\n");
		printf("failures. Removing the cable and equipment may allow Autocalibration and\n");
		printf("the sebsequent tests to complete successfully.\n");
		printf("\n");
	}

	return(errs);
}


