// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS16AO2/samples/sbtest/autocal_status.c $
// $Rev: 55949 $
// $Date: 2024-11-13 13:38:37 -0600 (Wed, 13 Nov 2024) $

// 16AISS16AO2: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	// There are no persistant bits to test.
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AUTOCAL,
			/* arg		*/	0,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	ret;
	s32	sts		= 0;

	errs	+= aiss16ao2_initialize(fd, -1, 0);

	ret		= aiss16ao2_ioctl(fd, AISS16AO2_IOCTL_AUTOCAL_STATUS, &sts);
	errs	+= ret ? 1 : 0;

	if ((errs == 0) && (sts != AISS16AO2_AUTOCAL_STATUS_PASS))
	{
		errs++;
		printf("FAIL <---  (%d. status != PASS)\n", __LINE__);
	}

	errs	+= service_ioctl_set_reg_list(fd, list);

	ret		= aiss16ao2_ioctl(fd, AISS16AO2_IOCTL_AUTOCAL_STATUS, &sts);
	errs	+= ret ? 1 : 0;

	if ((errs == 0) && (sts != AISS16AO2_AUTOCAL_STATUS_PASS))
	{
		errs++;
		printf("FAIL <---  (%d. status != PASS)\n", __LINE__);
	}

	errs	+= aiss16ao2_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	autocal_status_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AISS16AO2_IOCTL_AUTOCAL_STATUS.
*		We can't verify that an autocalibration was performed, so we simply
*		check that the respective bits are correct afterwards.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int autocal_status_test(int fd)
{
	int	errs	= 0;

	gsc_label("AISS16AO2_IOCTL_AUTOCAL_STATUS");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


