// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS16AO2/utils/ao_buf_load_req.c $
// $Rev: 55942 $
// $Date: 2024-11-13 13:29:08 -0600 (Wed, 13 Nov 2024) $

// 16AISS16AO2: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	aiss16ao2_ao_buf_load_req
*
*	Purpose:
*
*		Provide a visual wrapper for the AISS16AO2_IOCTL_AO_BUF_LOAD_REQ service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	aiss16ao2_ao_buf_load_req(int fd, int index, int verbose)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("AO Buffer Load Request", index);

	ret		= aiss16ao2_ioctl(fd, AISS16AO2_IOCTL_AO_BUF_LOAD_REQ, NULL);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s\n", errs ? "FAIL <---" : "PASS");

	return(errs);
}


